require 'json'

require 'oversip-mod-callsign/identity'

module OverSIP
  module Modules
    module Callsign
      class Token
        attr_accessor :access_token
        attr_accessor :client_id
        attr_accessor :identity
        attr_accessor :scope
        attr_accessor :revision
        attr_accessor :expires_in
        attr_accessor :token_type

        def scopes
          @scopes ||= @scope.split ' '
        end

        def initialize(access_token, client_id, identity, scope, revision, expires_in, token_type)
          @access_token = access_token
          @client_id = client_id
          @identity = Identity.parse identity
          @scope = scope
          @revision = revision
          @expires_in = expires_in
          @token_type = token_type
        end

        def self.from_json(json_string)
          json = JSON.parse(json_string)
          Token.new json['access_token'], json['client_id'], json['identity'], json['scope'], json['revision'], json['expires_in'], json['token_type']
        end
      end
    end
  end
end