require 'eventmachine'

module OverSIP
  module Modules
    module Callsign
      class TokenCache
        def get(token)
          @cache[token]
        end

        def set(token, data)
          @cache[token] = data
          EventMachine.add_timer(@token_ttl) { @cache.delete(token) }
        end

        def initialize(token_ttl=10)
          @cache = {}
          @token_ttl = token_ttl
        end
      end
    end
  end
end